Grand.Plugin.Shipping.ShippingPoint/Controllers/ShippingPointController.cs
using Grand.Core;
using Grand.Services.Localization;
using Grand.Framework.Controllers;
using Grand.Services.Common;
using Grand.Plugin.Shipping.ShippingPoint.Models;
using Grand.Plugin.Shipping.ShippingPoint.Services;
using Grand.Framework.Kendoui;
using Grand.Services.Security;
using Grand.Framework.Mvc;
using Grand.Services.Directory;
using Grand.Services.Stores;
using Grand.Services.Catalog;
using Grand.Framework.Mvc.Filters;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.Rendering;
using System.Threading.Tasks;
using Grand.Framework.Security.Authorization;

namespace Grand.Plugin.Shipping.ShippingPoint.Controllers
{
    [AuthorizeAdmin]
    [Area("Admin")]
    [PermissionAuthorize(PermissionSystemName.ShippingSettings)]
    public class ShippingPointController : BaseShippingController
    {
        private readonly IWorkContext _workContext;
        private readonly IStoreContext _storeContext;
        private readonly IGenericAttributeService _genericAttributeService;
        private readonly ILocalizationService _localizationService;
        private readonly IShippingPointService _shippingPointService;
        private readonly ICountryService _countryService;
        private readonly IStoreService _storeService;
        private readonly IPriceFormatter _priceFormatter;

        public ShippingPointController(
            IWorkContext workContext,
            IStoreContext storeContext,
            IGenericAttributeService genericAttributeService,
            ILocalizationService localizationService,
            IShippingPointService ShippingPointService,
            ICountryService countryService,
            IStoreService storeService,
            IPriceFormatter priceFormatter
            )
        {
            _workContext = workContext;
            _storeContext = storeContext;
            _genericAttributeService = genericAttributeService;
            _localizationService = localizationService;
            _shippingPointService = ShippingPointService;
            _countryService = countryService;
            _storeService = storeService;
            _priceFormatter = priceFormatter;
        }

        public IActionResult Configure()
        {
            return View("~/Plugins/Shipping.ShippingPoint/Views/Configure.cshtml");
        }

        [HttpPost]
        public async Task<IActionResult> List(DataSourceRequest command)
        {
            var shippingPoints = await _shippingPointService.GetAllStoreShippingPoint(storeId: "", pageIndex: command.Page - 1, pageSize: command.PageSize);
            var viewModel = new List<ShippingPointModel>();

            foreach (var shippingPoint in shippingPoints)
            {
                var storeName = await _storeService.GetStoreById(shippingPoint.StoreId);
                viewModel.Add(new ShippingPointModel
                {
                    ShippingPointName = shippingPoint.ShippingPointName,
                    Description = shippingPoint.Description,
                    Id = shippingPoint.Id,
                    OpeningHours = shippingPoint.OpeningHours,
                    PickupFee = shippingPoint.PickupFee,
                    StoreName = storeName != null ? storeName.Shortcut : _localizationService.GetResource("Admin.Configuration.Settings.StoreScope.AllStores"),

                });
            }

            return Json(new DataSourceResult
            {
                Data = viewModel,
                Total = shippingPoints.TotalCount
            });
        }

        private async Task<ShippingPointModel> PrepareShippingPointModel(ShippingPointModel model)
        {
            model.AvailableCountries.Add(new SelectListItem { Text = _localizationService.GetResource("Admin.Address.SelectCountry"), Value = string.Empty });
            foreach (var country in await _countryService.GetAllCountries(showHidden: true))
                model.AvailableCountries.Add(new SelectListItem { Text = country.Name, Value = country.Id.ToString() });
            model.AvailableStores.Add(new SelectListItem { Text = _localizationService.GetResource("Admin.Configuration.Settings.StoreScope.AllStores"), Value = string.Empty });
            foreach (var store in await _storeService.GetAllStores())
                model.AvailableStores.Add(new SelectListItem { Text = store.Shortcut, Value = store.Id.ToString() });
            return model;
        }

        public async Task<IActionResult> Create()
        {
            var model = new ShippingPointModel();
            await PrepareShippingPointModel(model);
            return View("~/Plugins/Shipping.ShippingPoint/Views/Create.cshtml", model);
        }

        [HttpPost]
        public async Task<IActionResult> Create(ShippingPointModel model)
        {
            if (ModelState.IsValid)
            {
                var shippingPoint = model.ToEntity();
                await _shippingPointService.InsertStoreShippingPoint(shippingPoint);

                ViewBag.RefreshPage = true;
            }

            await PrepareShippingPointModel(model);

            return View("~/Plugins/Shipping.ShippingPoint/Views/Create.cshtml", model);
        }

        public async Task<IActionResult> Edit(string id)
        {
            var shippingPoints = await _shippingPointService.GetStoreShippingPointById(id);
            var model = shippingPoints.ToModel();
            await PrepareShippingPointModel(model);
            return View("~/Plugins/Shipping.ShippingPoint/Views/Edit.cshtml", model);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(ShippingPointModel model)
        {
            if (ModelState.IsValid)
            {
                var shippingPoint = await _shippingPointService.GetStoreShippingPointById(model.Id);
                shippingPoint = model.ToEntity();
                await _shippingPointService.UpdateStoreShippingPoint(shippingPoint);
            }
            ViewBag.RefreshPage = true;

            await PrepareShippingPointModel(model);

            return View("~/Plugins/Shipping.ShippingPoint/Views/Edit.cshtml", model);
        }

        [HttpPost]
        public async Task<IActionResult> Delete(string id)
        {
            var model = await _shippingPointService.GetStoreShippingPointById(id);
            await _shippingPointService.DeleteStoreShippingPoint(model);

            return new NullJsonResult();
        }
 
    }
}

Grand.Plugin.Shipping.ShippingPoint/Views/Configure.cshtml
@{
    Layout = "_ConfigurePlugin";

}

<form asp-controller="ShippingPoint" asp-action="Configure" method="post" id="shipping-instore-form">
    
    <div class="panel-group">
        <div class="panel panel-default">
            <div class="panel-body">
                <div id="shipping-points-grid"></div>
                <script>
                    $(document).ready(function() {
                        $("#shipping-points-grid").kendoGrid({
                            dataSource: {
                                type: "json",
                                transport: {
                                    read: {
                                        url: "@Html.Raw(Url.Action("List", "ShippingPoint"))",
                                        type: "POST",
                                        dataType: "json",
                                        data: addAntiForgeryToken
                                    },
                                    destroy: {
                                        url: "@Html.Raw(Url.Action("Delete", "ShippingPoint"))",
                                        type: "POST",
                                        dataType: "json",
                                        data: addAntiForgeryToken
                                    }
                                },
                                schema: {
                                    data: "Data",
                                    total: "Total",
                                    errors: "Errors",
                                    model: {
                                        id: "Id"
                                    }
                                },
                                requestEnd: function (e) {
                                    if (e.type == "update") {
                                        this.read();
                                    }
                                },
                                error: function(e) {
                                    display_kendoui_grid_error(e);
                                    this.cancelChanges();
                                },
                                serverPaging: true,
                                serverFiltering: true,
                                serverSorting: true
                            },
                            pageable: {
                                refresh: true,
                                numeric: false,
                                previousNext: false,
                                info: false
                            },
                            editable: {
                                confirmation: "@T("Admin.Common.DeleteConfirmation")",
                                mode: "inline"
                            },
                            scrollable: false,
                            columns: [ {
                                field: "ShippingPointName",
                                width: 200,
                                title: "@T("Plugins.Shipping.ShippingPoint.Fields.ShippingPointName")"
                            }, {
                                field: "OpeningHours",
                                width: 200,
                                title: "@T("Plugins.Shipping.ShippingPoint.Fields.OpeningHours")"
                            }, {
                                field: "PickupFee",
                                width: 150,
                                title: "@T("Plugins.Shipping.ShippingPoint.Fields.PickupFee")"
                            },{
                                field: "StoreName",
                                width: 100,
                                title: "@T("Plugins.Shipping.ShippingPoint.Fields.Store")"
                            }, {
                                field: "Id",
                                title: "@T("Admin.Common.Edit")",
                                width: 100,
                                template: "<input type='submit' value='@T("Admin.Common.Edit")' onclick=\"javascript:OpenWindow('@Url.Action("Edit", "ShippingPoint")?id=#=Id#&btnId=btnRefresh&formId=shipping-instore-form', 800, 800, true); return false;\" class='k-button k-button-icontext' />"
                            }, {
                                command: { name: "destroy", text: "@T("Admin.Common.Delete")" },
                                title: "@T("Admin.Common.Delete")",
                                width: 100
                            }]
                        });
                    });
                </script>
            </div>
            <div class="panel-footer">
                <input type="submit" id="btnAddNewOption" class="btn btn-primary" value="@T("Admin.Common.AddNew")" onclick="javascript:OpenWindow('@(Url.Action("Create", "ShippingPoint") + "?btnId=btnRefresh&formId=shipping-instore-form")', 800, 800, true); return false;" />
                <input type="submit" id="btnRefresh" class="btn btn-default" style="display: none" />
            </div>

            <script>
                $(document).ready(function () {
                    $('#btnRefresh').click(function () {
                        var grid = $("#shipping-points-grid").data('kendoGrid');
                        grid.dataSource.read();
                        return false;
                    });
                });
            </script>

        </div>
    </div>
</form>

Grand.Plugin.Shipping.ShippingPoint/Views/Create.cshtml
@{
    Layout = "_AdminPopupLayout";
}
@model Grand.Plugin.Shipping.ShippingPoint.Models.ShippingPointModel

<form asp-controller="ShippingPoint" asp-action="Create" method="post"
      asp-route-ShippingPointId="@Context.Request.Query["ShippingPointId"]"
      asp-route-btnId="@Context.Request.Query["btnId"]"
      asp-route-formId="@Context.Request.Query["formId"]">
    
    <div class="row">
        <div class="col-md-12">
            <div class="x_panel light form-fit">
                <div class="x_title">
                    <div class="caption">
                        @T("Admin.Common.AddNew")
                    </div>
                    <div class="actions">
                        <div class="btn-group btn-group-devided">
                            <button class="btn btn-success" type="submit" name="save"><i class="fa fa-check"></i> @T("Admin.Common.Save") </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="content">
        <div class="form-horizontal">
            <partial name="~/Plugins/Shipping.ShippingPoint/Views/_CreateOrUpdate.cshtml" model="Model" />
        </div>
    </div>
</form>

Grand.Plugin.Shipping.ShippingPoint/Views/Edit.cshtml
@{
    Layout = "_AdminPopupLayout";
}
@model Grand.Plugin.Shipping.ShippingPoint.Models.ShippingPointModel

<form asp-controller="ShippingPoint" asp-action="Edit" method="post"
        asp-route-ShippingPointId="@Context.Request.Query["ShippingPointId"]"
        asp-route-btnId="@Context.Request.Query["btnId"]"
        asp-route-formId="@Context.Request.Query["formId"]">
    
    <div class="row">
        <div class="col-md-12">
            <div class="x_panel light form-fit">
                <div class="x_title">
                    <div class="caption">
                        @T("Admin.Common.Edit")
                    </div>
                    <div class="actions">
                        <div class="btn-group btn-group-devided">
                            <button class="btn btn-success" type="submit" name="save"><i class="fa fa-check"></i> @T("Admin.Common.Save") </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="content">
        <div class="form-horizontal">
            <partial name="~/Plugins/Shipping.ShippingPoint/Views/_CreateOrUpdate.cshtml" model="Model" />
        </div>
    </div>
</form>

Grand.Plugin.Shipping.ShippingPoint/Views/FormComboBox.cshtml
@model List<SelectListItem>
<script>
    function renderShippingOptionInfo(param) {
        if (param != "") {
            var _url = '/SelectedShippingPoint/Get?shippingOptionId=' + param;
            $.ajax({
                url: _url,
                success: function (data) {
                    $("#shippingOptionInfo").html(data);
                }
            });
        }
        else {
            $("#shippingOptionInfo").html("");
        }
    }
</script>

<h6>@T("Plugins.Shipping.ShippingPoint.ChooseShippingPoint")</h6>
<select class="form-control" name="selectedShippingOption" onchange="renderShippingOptionInfo(value)">
    @foreach (var shippingOption in Model)
    {
        <option value="@shippingOption.Value">@shippingOption.Text</option>
    }
</select>

<div id="shippingOptionInfo"></div>

Grand.Plugin.Shipping.ShippingPoint/Views/FormShippingOption.cshtml
@model Grand.Plugin.Shipping.ShippingPoint.Models.PointModel

<div class="form-horizontal">
    <div class="form-body">
        <div class="row">
            <div class="col-md-2 text-right">@T("Plugins.Shipping.ShippingPoint.ShippingPointName")</div>
            <div class="col-md-10">@T("Plugins.Shipping.ShippingPoint.MethodAndFee", @Model.ShippingPointName, @Model.PickupFee)</div>
        </div>
        <div class="row">
            <div class="col-md-2 text-right"><label for="">@T("Plugins.Shipping.ShippingPoint.Address")</label></div>
            <div class="col-md-10">@Model.CountryName,&nbsp;@Model.ZipPostalCode&nbsp;@Model.City,&nbsp;@Model.Address1</div>
        </div>
    </div>
</div>

Grand.Plugin.Shipping.ShippingPoint/Views/_CreateOrUpdate.cshtml
@model Grand.Plugin.Shipping.ShippingPoint.Models.ShippingPointModel
@using Grand.Framework;

<div asp-validation-summary="All"></div>
<input asp-for="Id" type="hidden" />

@if (ViewBag.RefreshPage == true)
{
    <script>
        try {window.opener.document.forms['@(Context.Request.Query["formId"])'].@(Context.Request.Query["btnId"]).click();}
        catch (e){}
        window.close();
    </script>
}

<div class="form-horizontal">
    <div class="form-body">
        <div class="form-group">
            <admin-label asp-for="ShippingPointName" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="ShippingPointName" />
                <span asp-validation-for="ShippingPointName"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="Description" />
            <div class="col-md-9 col-sm-9">
                <admin-textarea asp-for="Description"></admin-textarea>
                <span asp-validation-for="Description"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="CountryId" />
            <div class="col-md-9 col-sm-9">
                <admin-select asp-for="CountryId" asp-items="Model.AvailableCountries" />
                <span asp-validation-for="CountryId"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="City" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="City" />
                <span asp-validation-for="City"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="Address1" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="Address1" />
                <span asp-validation-for="Address1"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="ZipPostalCode" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="ZipPostalCode" />
                <span asp-validation-for="ZipPostalCode"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="OpeningHours" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="OpeningHours" />
                <span asp-validation-for="OpeningHours"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="PickupFee" />
            <div class="col-md-9 col-sm-9">
                <admin-input asp-for="PickupFee" />
                <span asp-validation-for="PickupFee"></span>
            </div>
        </div>
        <div class="form-group">
            <admin-label asp-for="StoreId" />
            <div class="col-md-9 col-sm-9">
                <admin-select asp-for="StoreId" asp-items="Model.AvailableStores" />
                <span asp-validation-for="StoreId"></span>
            </div>
        </div>
    </div>
</div>